# -*- mode:python; coding:utf-8; tab-width:4 -*-

import itertools
import math

import Ice
Ice.loadSlice('-I {} cannon.ice'.format(Ice.getSliceDir()))
import Cannon


def matrix_add(A, B):
    order = A.ncols
    C = Cannon.Matrix(order, [])

	C.data=[0] * (order**2)
	for i in range (0, order): 
		for j in range (0, order): 
			C.data[i*order + j] = A.data[i*order + j] + B.data[i*order + j]

    return C

def matrix_multiply(A, B):
    order = A.ncols
    C = Cannon.Matrix(order, [])

    for i, j in itertools.product(xrange(order), repeat=2):
        C.data.append(
            sum(A.data[i * order + k] * B.data[k * order + j] for k in xrange(order))
        )

    return C

def matrix_horizontal_shift(A, block_order):
	order = A.ncols
	resultado = Cannon.Matrix(order, [])
	

	for i in range(0, order):
		desplazamiento = block_order * int(i/block_order)
		for j in range(0, order):
			dato = i*order+(j+desplazamiento)%order
			resultado.data.append(A.data[dato])
	
	return resultado

def matrix_vertical_shift(B, block_order):
	order=B.ncols
	resultado = Cannon.Matrix(order, [])
	for i in range(0, order):
		for j in range(0, order):
			desplazamiento = block_order * int(j/block_order)
			dato = ((i+desplazamiento)%order)*order+j
			resultado.data.append(B.data[dato])
	
	return resultado

def matrix_split(Matriz, block_order):
	bloques = []

	order = Matriz.ncols
	bloquesPorFila = int(order / block_order)
	numBloques = bloquesPorFila ** 2
	
	for idBloque in range(0, numBloques):
		bloques.insert(idBloque, Cannon.Matrix(block_order, []))

	for i in range(0, order):
		for j in range(0, order):
			idBloque = int(i/block_order) * int(bloquesPorFila) + int(j/block_order)
			posicion=i*order+j
			bloques[idBloque].data.append(Matriz.data[posicion])

    return bloques
	
def matrix_join(*bloques):
	nBloques = int(math.sqrt(len(bloques)))
    block_order = bloques[0].ncols
    order = nBloques * block_order
    
    resultado = Cannon.Matrix(order, [])
    
    for nVeces in range(nBloques):
    	for i in range(block_order):
    		pos = i * block_order 
    		bloque = nVeces * nBloques
    		for j in range(nBloques):
    			for inc in range(block_order):
    				resultado.data.append(bloques[bloque].data[pos + inc])
    			bloque = bloque + 1
    
    return resultado

