#!/usr/bin/python
# -*- mode:python; coding:utf-8; tab-width:4 -*-

import sys
import os
import Ice
Ice.loadSlice('-I {} cannon.ice'.format(Ice.getSliceDir()))
Ice.loadSlice('-I {} container.ice'.format(Ice.getSliceDir()))
import Services
import Cannon
import time
from matrix_utils import (matrix_multiply, matrix_add)

class ProcessorI(Cannon.Processor):
    def init(self, index, order, above, left, target, current=None):
        self.index=index
		self.order=order
		self.above=above
		self.left=left
		self.target=target
		self.MatrizA = [None] * order
		self.MatrizB = [None] * order
		self.Resultado = None
		self.suma = None
		self.nPasos = 0
		self.pasosMaximos = order
	

    def injectA(self, A, step, current=None):
		self.MatrizA[step] = A
		
		if(hasattr(self.MatrizB[step],"data")):
			self.multiplicar(step)

    def injectB(self, B, step, current=None):
		self.MatrizB[step] = B

		if(hasattr(self.MatrizA[step],"data")):
			self.multiplicar(step)

	def multiplicar(self, step):
		self.Resultado=matrix_multiply(self.MatrizA[step], self.MatrizB[step])
		if (self.suma == None) :
			self.suma = self.Resultado
		else:
			self.suma = matrix_add(self.suma, self.Resultado)
		
		self.nPasos += 1
		#comprobar con un test que funciona
		if (step < (self.pasosMaximos - 1)):
			self.left.injectA(self.MatrizA[step], step+1)
			self.above.injectB(self.MatrizB[step], step+1)
		if (self.nPasos == self.pasosMaximos):
			self.target.inject(self.index,self.suma)


class Server(Ice.Application):
    def run(self, args):
        broker = self.communicator()
        servant = ProcessorI()

        containerProxy= broker.stringToProxy(args[1])

        print ("Preparing container...")

        while 1:
            try:
                containerProxy.ice_ping()
                print ("Container ready"); break
            except Ice.NoEndpointException:
                time.sleep(1)

        container = Services.ContainerPrx.checkedCast(containerProxy)

        if not container:
            raise RuntimeError('Invalid proxy')

        adapter = broker.createObjectAdapter('ProcessorAdapter')

        n_clave=os.getpid()

        identificador = str(n_clave)

        proxy=adapter.add(servant, broker.stringToIdentity(identificador))

        container.link(identificador, proxy)


        print('processor ready: "{}"'.format(proxy))

        adapter.activate()
        self.shutdownOnInterrupt()
        broker.waitForShutdown()

        container.unlink(identificador)



if __name__ == '__main__':
    app = Server()
    sys.exit(app.main(sys.argv))
